#include <stdio.h>

#define N 15
#define S (N*N)

#define E(m, i, j)  *(m + N*i + j)

static float matrixA[S], matrixB[S], matrixC[S];

void init_matrices()
{
	float seed = 1.0;
	int i;
	for (i=0; i < S; i++)
	{
		matrixC[i] = 0.0;
		matrixA[i] = seed;
		matrixB[i] = seed + 1.0;
    seed = seed + 1.0;
	}
}

void print_matrix(float* matrix, char *str)
{
	int i,j;
	printf("Matrix %s\n", str);

	for (i=0; i < N; ++i)
	{
		for (j=0; j < N; ++j)
		{
			printf("%lf\t", E(matrix, i, j));
		}
		printf("\n");
	}
}

void print_matrices()
{
	float *A = matrixA;
  float *B = matrixB;
	float *C = matrixC;
	print_matrix(A, "A");
	print_matrix(B, "B");
	print_matrix(C, "C");
}

void multiply_matrices()
{
	float *A = matrixA;
  float *B = matrixB;
	float *C = matrixC;
	int i,j,k;

	for (i=0; i <N ; ++i)
	{
		for (j=0; j <N; ++j)
		{
			float s = 0.0;
			for (k=0; k < N; ++k)
			{
				float aval = E(A, i, k);
        float bval = E(B, k, j);
				s = s + (aval*bval);
			}
			E(C, i, j) = s;
		}
	}
}

int main()
{
	float *A, *B, *C;
	int i,j;

	init_matrices();
  for (j=0; j < 1000; ++j)
	 for (i=0; i < 1000; ++i)
			multiply_matrices();

	print_matrices();
}
